#ifndef _BTABLE
#define _BTABLE

#define BOARD_MAX 6      /* maximum number of modules on any board */

typedef struct {
  int rrb_id;            /* id of rps-rpm bridge */
  int id;                /* board id */
  int board_version;     /* a model number */
  int nMods;             /* The number of slots for processors on this board */ 
  char *mods[BOARD_MAX]; /* the rpm-style names */
  int globalFree;        /* for simulation, 1 if global bus is available */
  double busyTime;       /* time for which global bus is occupied */
} BOARD;

BOARD      *BTable_Lookup(int, int);  /* rrb_id, id */
BOARD      *BTable_LookupMod(char *); /* find board with given module */
int         BTable_Insert( BOARD *); /* return 1 if id already taken or mod already assigned, 0 otherwise */
void        BTable_Print(void);
BOARD      *BTable_IterateInit(void);   /* initialize THE iterator, return 1st element */
BOARD      *BTable_IterateNext(void);  /* return next element of list */
int         BTable_GetPosition(char *); /* return position on board of given module (-1 if not found) */
#endif
