#ifndef L2_BUFFMAP
#define L2_BUFFMAP


struct L2FR_BM_Entry {
  int   board;
  int   chip;
  int   addr;
  int   plane;
  int   absSect; /* This should go away with new geo */
  float pitch;   /* This should also disappear with new geo */
  int   first;
  int   last;
};
typedef struct L2FR_BM_Entry L2FR_BM_Entry;

/*
   It's not clear to me that the following two structures belong here. They
   should probably be turned into "objects". They will be used by mapper.
   (Gotta move fast at the moment.)
*/

struct L2FR_BMSectMap {
  float xMin[2];
  float xMax[2];
  float yMin[2];
  float yMax[2];
  float zWin[2];
  int   nLayers;
  int   firstLayer;
};
typedef struct L2FR_BMSectMap L2FR_BMSectMap;

struct L2FR_BMLayerMap {
  int   layer;
  int   absSect;
  float xMin; /* These numbers should indicate the edge of the active area */
  float xMax;
  float yMin;
  float yMax;
  float zWin;
  float pitch;
  int nEntries; /* in buffermap */
  int first;    /* offset to first entry */
};
typedef struct L2FR_BMLayerMap L2FR_BMLayerMap;

#define L2FR_MAX_BM_INDEX 2500 /* > the number of tracking layers */
#define L2FR_N_SECTIONS   18 /*This will go to 20 in the new geometry*/

int  L2fr_BuffMapInit();
int  L2fr_BuffMapRead();

void L2fr_BuffMapInsert( L2FR_BM_Entry *);
void L2fr_BuffMapPrintTable(FILE *);
void L2fr_BuffMapPrintSectMap(FILE *);
void L2fr_BuffMapPrintLayerMap(FILE *);
void L2fr_BuffMapPrintEntry(L2FR_BM_Entry *, FILE *);

L2FR_BM_Entry *L2fr_BuffMapLookup(int);     /* Return pointer to 1st entry */
L2FR_BM_Entry *L2fr_BuffMapIterateInit();   /* initialize THE iterator, return 1st element */
L2FR_BM_Entry *L2fr_BuffMapIterateNext();   /* return next element of list */


#endif
