/***
 *
 * This is a copy of the header file from the online source file tree.
 * (version of Apr 9, 1997. No changes have been made.
 * Of course, it's dangerous to make copies but the online/offline
 * codes are not yet well integrated, so...
 ***/

#ifndef _COMPONENT_H
#define _COMPONENT_H

#ifdef COMMENT
/*-------------------------------------------------------------------------*
 *                                                                         *
 *                       HERA-B  Component  IDs                            *
 *                                                                         *
 *    This header file lists the component IDs used in the HERA-B          *
 *    data acquisition. The names defined are as follows:                  *
 *                                                                         *
 *    COMP_N_<comp>     the component number for <comp>                    *
 *    COMP_M_<comp>     the component mask (used by emg and grr)           *
 *    COMP_ID_<comp>    the component id used in data records              *
 *                                                                         *
 *    The short component name used here (<comp>) means the following      *
 *                                                                         *
 *    <comp>  comp#  detector           <comp>  comp#  detector            *
 *     DAQ      0    Data Acquisition    MUON     8    Muon tubes          *
 *     SVD      1    Silicon strips      MPIX     9    Muon pixels         *
 *     ITR      2    Inner tracker       MPAD    10    Muon pads           *
 *     HIPT     3    High-Pt chambers    FLT     11    1st level trigger   *
 *     OTR      4    Outer tracker       SLT     12    2nd level trigger   *
 *     RICH     5    RICH                FARM    13    3rd level farm      *
 *     TRD      6    TRD                 TARG    14    Target              *
 *     ECAL     7    EM Calorimeter                                        *
 *                                                                         *
 *                                                                         *
 *-------------------------------------------------------------------------*/
#endif

#define COMP_N_DAQ   0
#define COMP_M_DAQ   0x00000001
#define COMP_ID_DAQ  0x0000

#define COMP_N_SVD   1
#define COMP_M_SVD   0x00000002
#define COMP_ID_SVD  0x0100

#define COMP_N_ITR   2
#define COMP_M_ITR   0x00000004
#define COMP_ID_ITR  0x0200

#define COMP_N_HIPT  3
#define COMP_M_HIPT  0x00000008
#define COMP_ID_HIPT 0x0300

#define COMP_N_OTR   4
#define COMP_M_OTR   0x00000010
#define COMP_ID_OTR  0x0400

#define COMP_N_RICH  5
#define COMP_M_RICH  0x00000020
#define COMP_ID_RICH 0x0500

#define COMP_N_TRD   6
#define COMP_M_TRD   0x00000040
#define COMP_ID_TRD  0x0600

#define COMP_N_ECAL  7
#define COMP_M_ECAL  0x00000080
#define COMP_ID_ECAL 0x0700

#define COMP_N_MUON  8
#define COMP_M_MUON  0x00000100
#define COMP_ID_MUON 0x0800

#define COMP_N_MPIX  9
#define COMP_M_MPIX  0x00000200
#define COMP_ID_MPIX 0x0900

#define COMP_N_MPAD  10
#define COMP_M_MPAD  0x00000400
#define COMP_ID_MPAD 0x0a00

#define COMP_N_FLT   11
#define COMP_M_FLT   0x00000800
#define COMP_ID_FLT  0x0b00

#define COMP_N_SLT   12
#define COMP_M_SLT   0x00001000
#define COMP_ID_SLT  0x0c00

#define COMP_N_FARM  13
#define COMP_M_FARM  0x00002000
#define COMP_ID_FARM 0x0d00

#define COMP_N_TARG  14
#define COMP_M_TARG  0x00004000
#define COMP_ID_TARG 0x0e00

#define COMP_N_FCS   15
#define COMP_M_FCS   0x00008000
#define COMP_ID_FCS  0x0f00

#endif
