#ifndef _CTABLE
#define _CTABLE

typedef struct {
  char *mod1;  /* the rpm name of 1st mod (sender if unidirectional) */
  int   link1;
  char *mod2;  /* receiver if unidirectional */
  int   link2;
} CONNECTION;

typedef enum {CTABLE_ALL, CTABLE_TO, CTABLE_FROM} CTABLE_ITER_TYPE;
typedef enum {CTABLE_EITHER, CTABLE_INPUT, CTABLE_OUTPUT} CTABLE_DIRECTION;

CONNECTION *CTable_Lookup(char *, int); 
int         CTable_Insert( CONNECTION *); /* return 1 if either link is already connected, 0 otherwise */
void        CTable_Print(void);
CONNECTION *CTable_IterateInit(CTABLE_ITER_TYPE, char *);   /* initialize THE iterator, return 1st element */
CONNECTION *CTable_IterateNext();         /* return next element of list */
int         CTable_IsConnected(char *, CTABLE_DIRECTION); /* return 1 if module has a connection in specified
							     direction (seen from mod), 0 otherwise */
int         CTable_GetNumber();           /* return the number of connections in the table */
void        CTable_Destruct();

#endif
