#ifndef _GRR
#define _GRR

/*
 *    Define the system error codes.
 */
enum grr_codes {
    GRR_OK,                   /* normal succesful return          */
    GRR_FISHY,                /* normal error return              */
    GRR_TIME,                 /* request timed out                */
    GRR_KNOWN,                /* name already defined             */
    GRR_DEFINED,              /* redundant                        */
    GRR_UNKNOWN,              /* name not known by server         */
    GRR_OPENED,               /* channel already open             */
    GRR_OVERFLOW,             /* message overflows buffer         */
    GRR_TOO_LONG,             /* redundant                        */
    GRR_INVALID,              /* invalid Parameter                */
    GRR_FAILURE,              /* flood failed                     */
    GRR_REJECT,               /* server rejected flood            */
    GRR_SYNTAX,               /* syntax error                     */
    GRR_BAD_TYPE,             /* invalid data type                */
    GRR_EMPTY,                /* queue or list empty              */
    GRR_CLOSED,               /* channel is not open              */
    GRR_BAD_ADDRESS,          /* passed an invalid address        */
    GRR_SPECIFIC};            /* start of package specific codes. */
                              /* This must be the last GRR code   */
/*
 *    grr severity levels
 */
enum grr_severity {
    GRR_SINFO,
    GRR_SWARNING,
    GRR_SERROR,
    GRR_SEVERE,
    GRR_SFATAL};
/*
 *   grr routines
 */
int grr_error(int ,const char *, int);


#endif

