#ifndef _L2MODE
#define _L2MODE

enum L2_SCENARIO {
  L2_98_L1SIM,          /* Fedor's ecal pretrigger, magnet off, no chambers, no CARE */
  L2_98_NO_CHAMBERS,    /* no l1simu, CARE in FLTE, magnet off, no chambers          */
  L2_98_STANDARD,       /* no l1simu, CARE in FLTE, magnet off, MC01 & MC02          */
  L2_98_FULL_CHAMBERS,  /* no l1simu, CARE in FLTE, magnet off, all chambers         */
  L2_98_MAGNET_ON,      /* CARE in FLTE, magnet on, no chambers                      */
  L2_STANDARD           /* final HeraB detector, standard l1simu, magnet on          */
};

enum L2_SI_CONFIG {
  L2_FULL_SILICON,         /* The whole detector */
  L2_3456_SILICON,         /* Layers 3,4,5,6, all sectors, all layers */
  L2_98_STANDARD_SILICON,  /* Layers 3,4,5,6, sectors 3,4, all layers */
  L2_98_REALISTIC_SILICON  /* 3: 3-1d, 4-1d; 4: 3-2d, 4-2d; 5: 3-2d, 4-2d 6: 1-1d, 2-1d+1s, 3-1d+1s, 4-1d */
  /* code: SL: sector - n_layers d [+ n_layers s] -- d = double, s = single */
  /* As given by Silvia Masciocchi at Zeuthen physics meeting 5.5.98       */
  /* Since I don't know which views are involved, I arbitrarily delete the highest numbered layers */

};

void L2Mode_set(int mode, int silicon, int magOn);
void L2Mode_get(int *mode, int *silicon);

#endif
