/***
 *
 * Stuff needed for setting up routing tables.
 *
 ***/

#ifndef _L2NET
#define _L2NET

#include "rps.h"

#define L2NET_LOCAL         0
#define L2NET_NO_WAY      111
#define L2NET_GLOBAL        7  /* This disallows modtypes with more than 6 links */
#define L2NET_GLOBAL_LAST  13

typedef int L2NODE;

/***  L2NODE conventions: ***

1-6     deliver to corresponding link
7-13    deliver via global bus to board position after subtracting 100
0       deliver via global bus to position given in the board field of the destination
111     error: can't get there from here

***/

L2NODE   *L2net_GetRouteTable( const char *, int *);
RPS_addr  L2net_GetAddress( const char *);        /*Don't use this directly. see l2mdtls.h*/
RPS_addr *L2net_GetAddressT(const char *, int *); /*Don't use this directly. see l2mdtls.h*/
int       L2net_GetRouterID(char *node);
RPS_addr  L2net_GetNext(RPS_addr current, RPS_addr dest);
void      L2net_PrintRouteTable( L2NODE *, int);
void      L2net_PrintPath(int, int);
void      L2net_PrintPathM(char *, char *);
int       L2net_AutoRoute(int);

#endif
