/***
   *
   * Target information.
   *
   * The structure is a copy of the 01-07 Arte bank.
   *
   ***/

#ifndef _L2TARG
#define _L2TARG

#include <stdio.h>

struct L2TARG {
  int cmp;
  int wnr;
  float dx;
  float dy;
  float dz;
  float x;
  float y;
  float z;
  float rot[3][3];
  float ms;
  float x0bm;
  float y0bm;
  float sxbm;
  float sybm;
};
typedef struct L2TARG L2TARG;

struct L2TBOX {
  float xmin;
  float xmax;
  float ymin;
  float ymax;
  float zmin;
  float zmax;
};
typedef struct L2TBOX L2TBOX; /* Define a window at fixed z */

int           l2targ_GetNTargs(void);    /* return the number of target wires */
const L2TARG *l2targ_GetTable(void);     /* return a pointer to the target table (Do not delete it!) */
const L2TARG *l2targ_Lookup(int);        /* return a pointer to the nth target            "          */
const L2TARG *l2targ_IterateInit();      /* iteration */
const L2TARG *l2targ_IterateNext();

void          l2targ_GetTargBox(L2TBOX *targ); /* get the minimal box enclosing target */
void          l2targ_PrintTargBox(L2TBOX *);
void          l2targ_ExpandBox(L2TBOX *t, float stretch); /* push out x,y sides by adding stretch */

void l2targ_Insert( L2TARG *);
void l2targ_PrintTable(FILE *);
void l2targ_PrintTarg(FILE *, L2TARG *);
void l2targ_ReadTable(FILE *, int nTargs);

#endif


