#ifndef _L2TRIG
#define _L2TRIG

#include "l2event.h"
#include "l1data.h"

/************ Functions for getting and setting track requirements *************/

/* 
   The available trigTypes are defined in l1data.h.
   At this time (24.5.98) flte produces events of type EE only

   The defaults can be found in l2trig.c, in the trigReq array.
   */

int L2trig_GetNFLTTracks( int trigType ); /* The number of FLT tracks (not settable) */
int L2trig_GetNTracks( int trigType );    /* The number of tracks required for an SLT trigger */
int L2trig_GetNWeak( int trigType );      /* The number of SLT-required tracks which may be "weak" */

int L2trig_SetNTracks( int trigType, int nTracks); /* The previous setting is returned */
int L2trig_SetNWeak( int trigType, int nWeak );    /* The previous setting is returned */

/************ for use by event.c routines only: ***************/

void     EventCheck(L2EVENT *pEvent);
void     EventCheckAll(L2EVENT *pEvent);

#endif
