#ifndef _LTABLE
#define _LTABLE

/* The "leg" table, in case you're wondering. Leg in the sense of part of a route. 
*/

#include "l2net.h"

typedef enum {LEG_ALL, LEG_TO, LEG_FROM} L_ITER_TYPE;

typedef struct {
  char *from;  /* sending router */ 
  char *to;    /* destination router */
  L2NODE via;  /* which link, or which mod id if by global */
} LEG;

LEG  *LTable_Lookup(char *, char *); 
int   LTable_Insert( LEG *);
void  LTable_Print(void);
LEG  *LTable_IterateInit(L_ITER_TYPE, char *); /* iterate over all, or specific from or to */
LEG  *LTable_IterateNext(void);

#endif
