
#ifndef _L2MOD_TOOLS
#define _L2MOD_TOOLS

#include "l2net.h"

/***
 *
 * L2mod_GetAddress, L2mod_GetAddressT
 *
 * These functions interface to the corresponding L2net routines. In
 * simulation mode, they get the requested address(es) from L2net_GetAddress(T),
 * enlarge current's L2ADDRLIST structure, store the address(es) there and
 * return a pointer to the address(es) (not the stored addresses, the ones
 * returned by the L2net calls...since the pointer to the L2ADDRLIST structure
 * is realloced which could leave dangling pointers in user code) to the user.
 * They are needed only to support automatic generation of module parameters. If
 * this becomes unnecessary in the future, the L2ADDRLIST pointer can be
 * deleted from the Mod structure (as well as nAddrLists) and the
 * L2net_GetAddr(T) calls made directly.
 *
 * FOR NOW, AT ANY RATE, MOD'S SHOULD USE THESE ROUTINES AND NOT THE
 * CORRESPONDING L2NET ROUTINES
 *
 ***/

RPS_addr  L2mod_GetAddress( char *);
RPS_addr *L2mod_GetAddressT( char *, int *);
RPS_addr *L2mod_GetAddressTo(char *myName, int *nAddrs);

#endif
