/*
 This file must be in the same directory as the l2simu frame headers
 since it's included in l2messtable.c. This needs fixing!

 The messages needed for oneone are defined here. This is hopefully
 the seed for the final implementation.
*/

#ifndef NF_MESSAGE_TYPES
#define NF_MESSAGE_TYPES

#include "class.h"
#include "L2S_messages.h"
#include "l2mess.h"

#include "l1data.h"
#include "pltable.h"

enum SUPR_MESS_TYPES {
  SUP_FLT_EVENT = (EVC_CLASS << 16) +1,
  SUP_REJ_EVENT,
  SUP_ACC_EVENT
};

enum SDS_MESS_TYPES {
  SDS_HIT_REQUEST = SDS_CLASS << 16,
  SDS_EVENT_REQUEST,
  SDS_HIT_REPLY,
  SDS_EVENT_REPLY
};

enum HOST_MESS_TYPES {
  HOST_INIT  = (L2S_CLASS << 16) + 1,
  HOST_RESET,
  HOST_GET_STATUS,
  GENERIC_STATUS_REPLY,
  SUPR_STATUS_REPLY,
  PROC_STATUS_REPLY,
  DIST_STATUS_REPLY
};


/***
 *
 * Supervisor messages
 *
 ***/


/* 
   The FLT message:
   
   For now, the FLT message just mirrors the data structures in l1data.h
   
   In the FLT message, the event structure comes first, followed by nTriggers Trigger
   structures, followed by nTracks track structures.
*/

typedef struct L2FR_L1Data  L2M_FLT_EVENT;
typedef struct L2FR_L1Trig  FLT_TRIGGER;


/***
 *
 * Messages to and from SLBs
 *
 ***/

/* This is of course temporary */

struct TSDS_HIT_REQUEST {
  int eventNumber;
  int reference;
  float x1;      /* this is just a copy of L2ROI */
  float x1_err;  /* I don't embed L2ROI here since this */
  float y1;      /* is a temporary solution. */
  float y1_err;
  float z1;
  float x2;
  float x2_err;
  float y2;
  float y2_err;
  float z2;
};
typedef struct TSDS_HIT_REQUEST TSDS_HIT_REQUEST;

#define MAX_ROI_HITS 400

struct L2M_HIT { /* temporary: this should be identical to L2HIT in l2event.h */
  int plane;
  int sl_rel;   /*PC1,MS10 = 0, PC2,MS11 = 1....TC2*/
  float rot;    /* hit coordinate */
  float offset; /* drift distance (or 0) */
  float res;
  float z;
  PLANE *pl;
};

typedef struct L2M_HIT L2M_HIT;   

struct TSDS_HIT_REPLY {
  int eventNumber;
  int reference;
  int nHits;
  int status;
  L2M_HIT hit[MAX_ROI_HITS];
};

#define SDS_NO_REQUEST 25 /* yup a kludge */

typedef struct TSDS_HIT_REPLY TSDS_HIT_REPLY;
  
struct  L2M_VERTEXGEO {
  int dum;
};
typedef struct  L2M_VERTEXGEO  L2M_VERTEXGEO;
  
struct L2M_TARGETGEO {
  int dum;
};
typedef struct  L2M_TARGETGEO  L2M_TARGETGEO;

/************************************************************************

 WARNING: The following definition is not bulletproof:
 It assumes that the FLT message is the longest and that
 the maximum number of FLT triggers is 100 and the max
 number of FLT tracks is 200.

**************************************************************************/


#define BUFF_SIZE  sizeof(RPS_hdr) + 200 *sizeof(L2FR_L1Track) \
+ 100 * sizeof(L2FR_L1Trig)

#define N_BUFFERS  20
#define POOL_SIZE  BUFF_SIZE * N_BUFFERS


void Mess_PrintHitReplyX(RPS_hdr *); /* defined in buff.c */

#endif
