#ifndef _PLDATA
#define _PLDATA
#
#define L2FR_MAX_ELEMENTS 9999
#define L2FR_MAX_HITS_PER_MIMP 5
#define L2FR_MAX_HITS_PER_PLANE 500
#
typedef struct {
    int event;      /* number of the event                            */
    int plane;      /* number of detector plane                       */
    int nhits;      /* number of hits in plane                        */
} L2FR_PlaneData;
#
typedef struct {
    float channel;  /* channel number (for now: xwire in meas dir.)   */
    float content;  /* drift time or amplitude (now xdistance or 0)   */
    float reso;     /* none (for now: resolution in meas dir.)        */
    float zpos;     /* none (for now: z position)                     */
} L2FR_PlaneDataHits;
#
typedef struct {
    float xMimp;  /* x (xprime) of Mimp                               */   
    float yMimp;  /* y (yprime) of Mimp                               */   
    float zMimp;  /* z          of Mimp                               */   
    int trkNum;   /* number of track causing Mimp                     */
    int trkID;    /* ID     of track causing Mimp                     */
    int listOfHits[L2FR_MAX_HITS_PER_MIMP]; /* numbers of related hits */
} L2FR_PlaneDataMimps;
#
L2FR_PlaneData *l2fr_PlDataLookup( int , int );
L2FR_PlaneData *l2fr_PlDataIterateInit();
L2FR_PlaneData *l2fr_PlDataIterateNext();
void l2fr_PlDataInsert(L2FR_PlaneData *);
void l2fr_PlDataPrintHeader(FILE *);
void l2fr_PlDataPrintTable(FILE *);
void l2fr_PlDataPrint(FILE *, int );
void l2fr_PlDataReadHeader(FILE *);
void l2fr_PlDataRead(FILE *, L2FR_PlaneData **);
void l2fr_PlDataClear();
#
#endif
