#ifndef REFIT
#define REFIT

#undef REFIT_DEBUG
#undef REFIT_DEBUG_X
#undef REFIT_DEBUG_Y
#undef REFIT_DEBUG_HITS
#undef REFIT_DEBUG_1
#undef REFIT_DEBUG_2
#undef REFIT_DEBUG_3

#define REFIT_MAX_SPLN 6
#define REFIT_MAX_DETTYPE 2
#define REFIT_MAX_SECT 12
#define REFIT_MAX_LAYER 8
#define REFIT_FIRST_SPLANE 29
#define REFIT_FIRST_PLANE 725
#define REFIT_LAST_PLANE 1446

#define REFIT_ROI_NSIGMA 0
#define REFIT_MAX_CAN 2000
#define REFIT_CHISQ_MAX 10.
#define REFIT_QUALITY_MAX 10000.
#define REFIT_HOLES_IN_SERIES 1
#define REFIT_CHISQ_SCALE 0.05
#define XZ_PROJ 0
#define YZ_PROJ 1
#define REFIT_INTDIFX 0.1
#define REFIT_INTDIFY 0.5
#define REFIT_SLPDIFX 0.0003
#define REFIT_SLPDIFY 0.0025

typedef struct {
   float intercept[2];
   float slope[2];
   float error[2];
   float xypos[2];
}PREDICT;

typedef struct {
    int nentries;
    L2REFITSUBTRK *pSubTrk[REFIT_MAX_SUBTRK];
}QUALITY;

typedef struct{
   int view;
   float z;
}REFIT_PLANE_GEO;

typedef struct {
   int view;
}REFIT_LAYER_GEO;

typedef struct{
   int nlayer[REFIT_MAX_SPLN][REFIT_MAX_DETTYPE];
   REFIT_LAYER_GEO Layer[REFIT_MAX_SPLN][REFIT_MAX_DETTYPE][REFIT_MAX_LAYER];
}REFIT_GEO;

#ifndef REFIT_DOT_C
#define REFIT_EXTERN extern
#else
#define REFIT_EXTERN
#endif

REFIT_EXTERN L2REFITSUBTRK Refit_Trkcan[REFIT_MAX_CAN];
REFIT_EXTERN L2REFITSUBTRK Refit_Trkcan_new[REFIT_MAX_CAN];
REFIT_EXTERN L2REFITSUBTRK Refit_Trkcan_best[REFIT_MAX_SUBTRK];

REFIT_EXTERN REFIT_GEO Refit_Geo;
REFIT_EXTERN L2HIT *Refit_l2Hit[REFIT_MAX_SPLN][REFIT_MAX_DETTYPE]; 
REFIT_EXTERN int Refit_nhit_spln[REFIT_MAX_SPLN];
REFIT_EXTERN int Refit_nhit_det[REFIT_MAX_SPLN][REFIT_MAX_DETTYPE];
#undef REFIT_EXTERN

static void RefitXDoTrk(L2REFITTRK *pRefitTrk);
static void RefitYDoRoI(L2TRACK *pTrk);
static void RefitYDoTrk(L2REFITTRK *pRefitTrk);
static BOOLEAN RefitX_Hit_NotInRoI(L2HIT *pHit, L2ROI *pRoI);
static BOOLEAN RefitY_Hit_NotInRoI(L2HIT *pHit, L2ROI *pRoI,
                L2REFITSUBTRK *pTrack);
static void RefitX_Update_Track(L2HIT *pHit, L2REFITSUBTRK *pTrack, 
                L2REFITSUBTRK *pTrack_new);
static void RefitY_Update_Track(L2HIT *pHit, L2REFITSUBTRK *pTrack, 
                L2REFITSUBTRK *pTrack_new);
static int RefitY_Track_InRoI(int ntrack, L2REFITSUBTRK *pTrack, L2ROI *pRoI);
void Refit_Init_Trk(L2TRACK *pTrk);
void Refit_Copy_SubTrack(L2REFITSUBTRK *pSubTrk, L2REFITSUBTRK *pSubTrk_new);
void Refit_Sort_Hits(L2HITSET *l2hitset);
PREDICT *Refit_Predict(float zpos, L2REFITSUBTRK *pTrack);
void Refit_Update_Hits(L2HIT *pHit, L2REFITSUBTRK *pTrack, 
                L2REFITSUBTRK *pTrack_new);
void Quality_List_Update(QUALITY *pQuality, L2REFITSUBTRK *pTrack, 
                int ntrack, L2REFITSUBTRK *pTrack_new);
int Refit_Clean_TrackList(int ntrack, L2REFITSUBTRK *pTrack);
BOOLEAN Refit_HolesInSeries(int view);
void L2Arte_GetMC(L2EVENT *pEvent, int *nbmc, L2ROI *pRoI,
       float coord[1000][8]);
#endif
