#ifndef _RTABLE
#define _RTABLE

#include "btable.h"   /* need BOARD_MAX */
#include "rps.h"

typedef struct {
  int id;                /* router node id */
  char *name;            /* module name of ths router */
  int nMods;             /* The number of modules serviced by this router */ 
  char *mods[BOARD_MAX]; /* the rpm-style names */
} ROUTER;

ROUTER     *RTable_Lookup(int); 
ROUTER     *RTable_LookupMod(char *);  /* find router which services given module */
ROUTER     *RTable_LookupName(const char *); /* look up by name */
RPS_addr    RTable_Address(const char *); /* assuming id == RPS address */
int         RTable_Insert( ROUTER *);   /* return 1 on error (see .c file), 0 otherwise */
int         RTable_AutoSet();            /* set up, after specification of over-riders */
int         RTable_GetTotal(void);
void        RTable_Print(void);
ROUTER     *RTable_IterateInit(void);   /* initialize THE iterator, return 1st element */
ROUTER     *RTable_IterateNext(void);  /* return next element of list */

#endif
