#ifndef _SLP
#define _SLP

#include "slp_error.h"

#define FLTE_CLASS USER2_CLASS /* okay for awhile */

typedef enum {       /* The event processing states         */
  SLP_UNREGISTERED,  /* Not registered with EVC             */
  SLP_WAIT,          /* Registered and waiting for an event */
  SLP_EVA1,          /* Building calorimeter                */
  SLP_FLTE,          /* Emulating FLT                       */
  SLP_SLT,           /* SLT                                 */
  SLP_EVA2,          /* Building event after SLT accept     */
  SLP_TLT,           /* TLT                                 */
  SLP_EVA3,          /* Transfering event to L4             */
} SLP_STEP;

typedef enum {       /* The SMC states */
  SLP_SMC_BRAINDEAD,
  SLP_SMC_INITIALIZED,
  SLP_SMC_READY,
  SLP_SMC_ERROR,
  SLP_SMC_STOP
} SLP_SMC_STATE;

typedef enum {        /* Return codes */
  SLP_SUCCESS,        /* (not event-related) message processed successfully, get next */
  SLP_ERROR,          /* irrecoverable error, force transition to SMC error state */
  SLP_ACCEPT,         /* event accepted, proceed to next step */
  SLP_REJECT,         /* event rejected, reset and continue */
  SLP_CONTINUE        /* processing step not finished, get new message */
} SLP_STAT;

typedef struct SLP_RETURN
{
   int event;
   SLP_STAT status;
   int error;
} SLP_RETURN;

#define SLP_NO_EVENT -1

SLP_RETURN SLP_initialize(void);
void SLP_proc(int isRPS, int msg_class, void *header, void *data);
SLP_RETURN  SLP_handle(int isRPS, int msg_class, void *header, void *data);
int SLP_GetFCSEventNumber(int event);
int SLP_GetBufferID(int event);


#endif
