#ifndef _SLP_MSG
#define _SLP_MSG

/*** SLP class messages ***/

#include "class.h"

#define SLP_CLASS USER1_CLASS /* okay for awhile */

enum SLP_MESS_TYPES {
  SLP_REGISTER = SLP_CLASS << 16,
  SLP_PROCESS_EVENT,
  SLP_FREE_READY,
  SLP_FREE_NOT_READY,
  SLP_STATUS_REQUEST,
  SLP_STATUS_REPLY,
  SLP_SDS_TIMEOUT
};

typedef struct TSLP_EVENT {
   int event;  /* As assigned by the FCS */
   int buffid; /* As assigned by EVC     */
   int status; /* Nonzero if an error is detected */
} TSLP_EVENT;

typedef struct TSLP_STATUS_REPLY {
   int nEvents;    /* Number of process requests received  */
   int nFLT;       /* Number of events accepted by FLT     */
   int nSLT;       /* Number of events accepted by SLT     */
   int nTLT;       /* Number of events accepted by TLT     */
   int nTimeouts;  /* Number of timeouts while waiting SDS */
   int RPSErrors;  /* Number of RPS errors detected        */
   int SDSErrors;  /* Number of SDS errors detected        */
   int RPMErrors;  /* Number of RPM errors detected        */
   int miscErrors; /* Number of any other type of errors   */
   int lastError;  /* Error code of last error seen        */
   int lastMess;   /* RPM type of last message processed   */
   int current;    /* Number of event being processed      */
   int buffid;     /* Buffer id of event being processed   */
   int step;       /* Current SLP processing step          */
} TSLP_STATUS_REPLY;

#endif
