#ifndef _SLTABLE
#define _SLTABLE

#include <stdio.h>
#include "pltable.h"

typedef struct {
    int l2nsl;    /* absolute number of superlayer          */
    char name[4]; /* superlayer name (up to 4 characters)   */
    int cmp;      /* detector component 1 (SIL),2 (WCH),... */
    int nsl;      /* n th superlayer of this component      */
    int mfl;      /* magnet flag (0 = no mag. field)        */
    int lay;      /* number of layers                       */
    float xo;     /* obsolete, do not use                   */
    float yo;     /* obsolete, do not use                   */
    float z1;     /* z of begin of superlayer               */
    float z2;     /* z of end   of superlayer               */
    int npl;      /* number of planes (nlayers * nsectors)  */
    int fpl;      /* first plane in this superlayer         */
} SUPERLAYER;

SUPERLAYER *SLLookup_bp(int, int);   /* by component type/plane, don't call from procs */
SUPERLAYER *SLLookup_bn(const char[4]); /* by arte name */
SUPERLAYER *SLLookup_pl(const PLANE *);

void SLInsert( SUPERLAYER *);   /* for use by Geo only */

SUPERLAYER *SL_IterateInit();   /* initialize THE iterator, return 1st element */
SUPERLAYER *SL_IterateNext();   /* return next element of list */

void SL_PrintTable(FILE *);     /* print geometry of all superlayers     */   
void SL_PrintSuperLayer(SUPERLAYER *, FILE *); /*as one line of an array initializer */
void SL_ReadSuperLayer(FILE *, SUPERLAYER **);            
void SL_PrintTableSpy(FILE *);  /* ...as an initialized arrray */

void L2_excludeSL( const char sl[5] );

#endif
