
#include <iostream.h>
#include "arte/Arte.hh"
#include "auto/GEDE.hh"
#include "care/care.hh"
#include <stdlib.h>

extern "C" {
#include "l2mode.h"
#include "l2geo.h"
#include "slt.h"
#include "flte.h"
#include "l2trig.h"

}

void l2init_(int scenario, int siliConfig);

extern int silicon_type;
extern int detector_mode;
extern float etcut;
extern float masscut;

extern "C"
{
 void usinit_()
 {

   int l2mode,silicon;

   //int l2mode = L2_98_FULL_CHAMBERS;
   //int l2mode = L2_98_STANDARD;
   //int l2mode = L2_98_MAGNET_ON;
   //int l2mode = L2_STANDARD;
   //int l2mode = L2_98_L1SIM;
   //int l2mode = L2_98_NO_CHAMBERS;

   //int silicon = L2_FULL_SILICON;
   //int silicon = L2_3456_SILICON;
   //int silicon = L2_98_STANDARD_SILICON;
   //int silicon = L2_98_REALISTIC_SILICON;

   l2mode=detector_mode;
   silicon=silicon_type;

   if(l2mode != L2_STANDARD && l2mode != L2_98_L1SIM)
     careinit_();

   SLT_setPrintOption(1); /* Print hit messages, if nonzero */
   l2init_(l2mode, silicon);

   //L2trig_SetNTracks( EE, 0);
   //L2trig_SetNWeak( EE, 1);

   char *onOff = (Geo_MagnetOn()) ? "on" : "off";
   cout <<"Geo_MagnetOn sez that the magnet is " << onOff << endl;

   l2targ_PrintTable(stdout);

   if(l2mode != L2_STANDARD && l2mode != L2_98_L1SIM) {
     cout << ">>>>>> FLT defaults <<<<<<" << endl;
     cout << "pt threshold: " << FLTE_getPtThreshold() << endl;
     cout << "Mass cut: " << FLTE_getMassCut() << endl;
     cout << "Ecal cluster width multiplier: " << FLTE_getECMultiplier() << endl;
     cout << "Target stretch factor: " << FLTE_getTargetStretch() << endl;
     cout << endl;

     FLTE_setPtThreshold(etcut);
     FLTE_setMassCut(masscut);
     //FLTE_setECMultiplier(0.2);
     //FLTE_setTargetStretch(.5);

     cout << ">>>>>> FLT updated values <<<<<<" << endl;
     cout << "pt threshold: " << FLTE_getPtThreshold() << endl;
     cout << "Mass cut: " << FLTE_getMassCut() << endl;
     cout << "Ecal cluster width multiplier: " << FLTE_getECMultiplier() << endl;
     cout << "Target stretch factor: " << FLTE_getTargetStretch() << endl;
     cout << endl;
   } else if(l2mode == L2_98_L1SIM) { // Only the stretch makes sense:
     cout << ">>>>>> Default target stretch: " << FLTE_getTargetStretch() << endl;
     FLTE_setTargetStretch(.09);
     cout << ">>>>>> Updated target stretch: " << FLTE_getTargetStretch() << endl;
   }

 }

}
